#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <malloc.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

/*
         I n t r u d e r s   f o r   l i n u x

           (c) P.V.C. software products, 1996

this source and include files that follows has been written
by Petr Votruba (c) 1996 
email or talk to pvc@lin.fsid.cvut.cz
*/

#define GAME_VERSION "Intruders for Linux,version 0.1"

/*
Values of MINFREQ and MAXFREQ depends on speed of your computer
*/
#define MINFREQ 30
#define MAXFREQ 60 

#define YES 0x00
#define NO 0xff

#define DESTROYED 0x00
#define ALIVE 0x01
#define TRANSMITTED 0x02
#define EXPLODING 0x03

#define MAXFIRES 20
#define MAXALIENFIRES 500

#define MAXALIENSINLEVEL 100
#define MAXSHELTERSINLEVEL 20

#define EXPLOSIONS 7
#define ALIENS 10
#define FIGHTERS 2
/*#define HYPERSPACES 6*/
#define TRANSS 5
#define SHELTERS 9

#define FRAMESPEREXPLOSION 4
#define FRAMESPERTRANSMISSION 5 
#define FRAMESPERFIRE 10
 
#define CHAOTIC 0x0
#define LINEAR  0x1
#define NONE    0x2


GraphicsContext *backscreen,*background,*physicalscreen;

FILE *pcx_in,*resultfile;

int VGAMODE;

int enemies,SCORE,LIVES,LEVEL,SHIELDS,TOUGHNESS;
int BACKGROUND=1,NO_OF_FIRES=0,NO_OF_HITS=0;

int GeneralFrameCounter,currclock,lastclock,level_height;
int frequency,FPS,waitcycle;
unsigned char me_hitted;
/*FPS means Frames Per Second*/

char LevelTitle[100];

int palettecounter,Me_x,Me_y,MyPhase,hsx,hsy,hsph,hsfreq,hsdir;
int i,m_button,leftcounter=0,midcounter=0,rightcounter=0;
int bodycount,FIRE_EFFICIENCY,Last_x,Last_y;

int no_of_shelters;

unsigned char *picture,font[256][8][8];

struct _2dpoint{
float x,y;
int colour;
} fire[MAXFIRES],alienfire[MAXALIENFIRES];

unsigned char *text_buffer;
unsigned char mouse_cursor[2][256],mouse_under[256];
unsigned char mouse_buffer[256],cbuf[256];

struct imagetype
{
unsigned char bitmap[256],mask[256];
} *explosions,*aliens,*fighters,*transs,*shelters;
/*
struct imagetype *hyperspaces;
*/


struct Sprite
{
float x,y;
unsigned char status,movement,hitted;
int counter,alientype,shields;
int vx,vy;/*speed in pixels per second*/

} XX[MAXALIENSINLEVEL];

/*alien guns description structure*/
struct _Alienguns{
int howmany,colour,shields;
struct _2dpoint offset[5];
} alienguns[ALIENS];

/*shelter behavoir description*/
struct _Shelter{
int type,movement,vx,vy,counter;
unsigned char hitted;
float x,y;
} Shelter[MAXSHELTERSINLEVEL];

struct _Score{
char name[14];
int efficiency,score,level;
} scoretable [10];

#include "./pcxloader.h"
#include "./loadlevel.h"
#include "./init.h"
#include "./gamecode.h"



void main(int argc,char *argv[]){

int n,n1,n2,n3,mouse;
unsigned char faster_mess=NO;
#ifndef IN_DEVEL
char string[160];
#endif

puts("\n");
puts(GAME_VERSION);
puts("\n");

GeneralFrameCounter=0;

palettecounter=16;

picture=NULL;

explosions=(struct imagetype *)malloc(sizeof(struct imagetype)*EXPLOSIONS);
aliens=(struct imagetype *)malloc(sizeof(struct imagetype)*ALIENS);
/*
hyperspaces=(struct imagetype *)malloc(sizeof(struct imagetype)*HYPERSPACES);
*/
fighters=(struct imagetype *)malloc(sizeof(struct imagetype)*FIGHTERS);
transs=(struct imagetype *)malloc(sizeof(struct imagetype)*TRANSS);
shelters=(struct imagetype *)malloc(sizeof(struct imagetype)*SHELTERS);

load_images();

vga_init();

mouse=vga_getmousetype();

if(mouse_init("/dev/ttyS0",mouse,MOUSE_DEFAULTSAMPLERATE)==-1){puts("mouse not found");
goto finish;};

mouse_setxrange(0,303);mouse_setyrange(120,192-16);

mouse_setscale(1);
mouse_setwrap(MOUSE_NOWRAP);
palettecounter=16;

/*If not in level-developement mode then show the start screen*/

#ifndef IN_DEVEL
vga_setmode(G360x480x256);
vga_clear();
sprintf(string,"%s/pics/startscreen.pcx",DIR);
picture=loadPCX(string);
for(n=16;n<256;n++)vga_setpalette(n,0,0,0);
vga_copytoplanar256(picture,360,0,360/4,360,480);
for(n2=0;n2<64;n2++){
for(n3=16;n3<256;n3++)
vga_setpalette(n3,(pal[n3-16].R*n2)/63,(pal[n3-16].G*n2)/63,(pal[n3-16].B*n2)/63);
usleep(5000);
}
for(;mouse_getbutton()==0;)mouse_waitforupdate();
for(n2=63;n2>=0;n2--){
for(n3=16;n3<256;n3++)
vga_setpalette(n3,(pal[n3-16].R*n2)/63,(pal[n3-16].G*n2)/63,(pal[n3-16].B*n2)/63);
usleep(3000);
}
vga_clear();
vga_setmode(TEXT);
free(picture);
picture=NULL;
palettecounter=16;
#endif

 
VGAMODE = G320x200x256; 
          
vga_setmode(VGAMODE);
gl_setcontextvga(VGAMODE);
physicalscreen = gl_allocatecontext();
gl_getcontext(physicalscreen);
                
#ifdef USE_PAGEFLIPPING
/* Try to enable page flipping. */
gl_enablepageflipping(&physicalscreen);
#endif
                                
gl_setcontextvgavirtual(VGAMODE);
backscreen = gl_allocatecontext();
gl_getcontext(backscreen);
#ifdef USE_SMALLOC
free(backscreen->vbuf);
backscreen->vbuf = smalloc(BYTEWIDTH * HEIGHT);
gl_setcontext(backscreen);
#endif
                                                            
gl_setcontextvgavirtual(VGAMODE);
background = gl_allocatecontext();
gl_getcontext(background);
#ifdef USE_SMALLOC
free(background->vbuf);
background->vbuf = smalloc(BYTEWIDTH * HEIGHT);
gl_setcontext(background);
#endif

gl_expandfont(8, 8, 7, gl_font8x8, font);
gl_setfont(8, 8, font);

gl_setwritemode(WRITEMODE_OVERWRITE);

SCORE=0;
LIVES=9;
LEVEL=0;
SHIELDS=100;
TOUGHNESS=3;

Me_x=160;Me_y=160;MyPhase=0;
hsx=300;hsy=3;hsph=0;hsfreq=3,hsdir=1;

InitAlienGuns();

NO_OF_FIRES=0;  

NO_OF_HITS=0;

lastclock=clock();
#ifndef IN_DEVEL
LEVEL=0;
#else
if(argc>1)sscanf(argv[1],"%d",&LEVEL);
else LEVEL=0;
#endif

new_level:
Me_x=Me_y=160;
mouse_setposition(Me_x,Me_y);
FPS=30;
waitcycle=10000;
GeneralFrameCounter=0;
palettecounter=16;
loadlevel(LEVEL);
level_height=0;
for(n=0;n<MAXFIRES;n++)fire[n].y=-3.;
for(n=0;n<MAXALIENFIRES;n++)alienfire[n].y=-3.;
bodycount=0;


n1=0;
for(;;){

shelters_job();
everything_moves();
test_collision();
have_I_got_it();
mouse_job();
draw_screen();

n1++;
if(n1==60){
for(n=0;n<enemies;n++)if(XX[n].status==ALIVE)alienFIRE(n);
n1=0;
};

if((LIVES==0)&&(SHIELDS<=0)){
vga_setmode(TEXT);
vga_init();
vga_setmode(G360x480x256);
if(picture!=NULL)free(picture);
palettecounter=16;
sprintf(string,"%s/pics/gameover.pcx",DIR);
picture=loadPCX(string);
for(n=16;n<256;n++)vga_setpalette(n,0,0,0);
vga_copytoplanar256(picture,360,0,360/4,360,480);
for(n2=0;n2<64;n2++){
for(n3=16;n3<256;n3++)
vga_setpalette(n3,(pal[n3-16].R*n2)/63,(pal[n3-16].G*n2)/63,(pal[n3-16].B*n2)/63);
usleep(5000);
};
mouse_waitforupdate();
for(;mouse_getbutton()==0;)mouse_waitforupdate();
for(n2=63;n2>=0;n2--){
for(n3=16;n3<256;n3++)
vga_setpalette(n3,(pal[n3-16].R*n2)/63,(pal[n3-16].G*n2)/63,(pal[n3-16].B*n2)/63);
usleep(3000);
}
vga_setmode(TEXT);
vga_init();
vga_setmode(VGAMODE); 
if(results()==0)goto game_over;
LEVEL=0;
LIVES=9;SHIELDS=100;
SCORE=0;
TOUGHNESS=3;
me_hitted=NO;
goto new_level;
};

for(n=0;n<enemies;n++)if(XX[n].status!=DESTROYED)goto dale;
LEVEL++;
if(LEVEL>LAST_LEVEL){LEVEL=0;TOUGHNESS+=5;};
goto new_level;

dale:

/*
why don't I use usleep() here? See framespeed() function.
clock() calculates time of process run, but usleep makes process sleeping
and disables clock() for that moment
*/

GeneralFrameCounter++;
if(GeneralFrameCounter==10)framespeed();
if(waitcycle<0){waitcycle=0;
if(faster_mess==NO){
/*puts("I had to set 'waitcycle' to zero... you'd better buy something faster");
  puts("or decrease the 'MINFREQ' value.");
*/
faster_mess=YES;};
}
for(n=0;n<waitcycle;n++);
if(FPS<MINFREQ)waitcycle-=700;
if(FPS>MAXFREQ)waitcycle+=700;
if((FPS>=MINFREQ)&&(FPS<=MAXFREQ))waitcycle-=500;

}

game_over:

finish:
mouse_close();
if(picture!=NULL)free(picture);

vga_clear();
vga_setmode(TEXT);

#ifndef USE_SMALLOC
gl_freecontext(backscreen);
gl_freecontext(background);
#endif
         
gl_freecontext(physicalscreen);


}

