#ifdef LEVEL_LOADER_DEBUG
#undef LEVEL_LOADER_DEBUG
#endif

/*#define LEVEL_LOADER_DEBUG*/

#define TITLE      100
#define BACKGROUND 101
#define END        102
#define ALIEN      103
#define ALIENLINE  104
#define ALIENBOX   105
#define SHELTER    106
#define FROM       107
#define TO         108
#define AT         109
#define TYPE       110
#define MOVEMENT   111
#define HOWMANY    112

void levelerror(int num,int line){
vga_setmode(TEXT);
printf("\nFile:%s/levels/level%d :\n",DIR,num);
printf("  error at line %d:\n",line);
}

int analyse_string(char *str){
int n;


if(strlen(str)==0)return -1;

for(n=0;n<strlen(str);n++){
str[n] = toupper(str[n]);
if(str[n]==' ')str[n]='\0';
}
#ifdef LEVEL_LOADER_DEBUG
printf("!!!  Analysing %s\n",str );
#endif
if(strcmp(str,"TITLE")==0)return TITLE;
if(strcmp(str,"BACKGROUND")==0)return BACKGROUND;
if(strcmp(str,"END")==0)return END;
if(strcmp(str,"ALIEN")==0)return ALIEN;
if(strcmp(str,"ALIENLINE")==0)return ALIENLINE;
if(strcmp(str,"ALIENBOX")==0)return ALIENBOX;
if(strcmp(str,"SHELTER")==0)return SHELTER;
if(strcmp(str,"FROM")==0)return FROM;
if(strcmp(str,"TO")==0)return TO;
if(strcmp(str,"AT")==0)return AT;
if(strcmp(str,"TYPE")==0)return TYPE;
if(strcmp(str,"MOVEMENT")==0)return MOVEMENT;
if(strcmp(str,"NONE")==0)return NONE;
if(strcmp(str,"LINEAR")==0)return LINEAR;
if(strcmp(str,"CHAOTIC")==0)return CHAOTIC;
if(strcmp(str,"HOWMANY")==0)return HOWMANY;
return -1;
}

int getnum(char *string){
char s[10];
int n,n1;
n1=0;
for(n=0;n<9;n++){
if(((string[n]<='9')&&(string[n]>='0'))||(string[n]=='-')){
s[n1]=string[n];
n1++;}
else {
s[n1]='\0';
goto scan;
};
}
scan:

sscanf(s,"%d",&n);
#ifdef LEVEL_LOADER_DEBUG
printf("scanning `%s\',found %d\n",s,n);
#endif
return n;
};

int loadlevel(int num){
FILE *file;
char string[160],znak,name[100];
int n,fromx=0,fromy=0,tox=1,toy=1,type=0,vx=100,vy=100;
int cntr,command,line,lastcommand;
int atx=0,aty=0,n1,n2,howmanyx=1,howmanyy=1,lastanalysis;
char levelfilename[100];
unsigned char movement=0;

#ifdef  LEVEL_LOADER_DEBUG
printf("Loading level %d\n",num);
#endif

if((num<0)||(num>99))return -1 ;
sprintf(levelfilename,"%s/levels/level%d",DIR,num);
if((file=fopen(levelfilename,"rt"))==NULL){
printf("Cannot open level datafile %s\n",levelfilename);
exit(-1);
};
lastcommand=END;
enemies=0;
no_of_shelters=0;
line=0;
command=END;

readline:
line++;
if(fgets(string,99,file)==NULL)goto fin;
/*for(n=0;n<99;n++){
n1=fgetc(file);
string[n]=(char)n1;
switch(n1){
case '\n':
case '\0':
case EOF:string[n]='\0';goto string_nacten;
default:break;
};
}
string_nacten:*/
for(n=0;n<99;n++)if(string[n]=='\n')string[n]='\0';
#ifdef LEVEL_LOADER_DEBUG
printf("line %d:%s\n",line,string);
#endif
cntr=0;
lastanalysis=0;

nextchar:
znak=string[cntr];
if(znak==10){
#ifdef LEVEL_LOADER_DEBUG
printf("\\n:%s -> going to readline\n",&string[cntr]);
printf("Hex:%02X %02X %02X %02X %02X %02X %02X %02X\n",string[cntr],
string[cntr+1],string[cntr+2],string[cntr+3],string[cntr+4],string[cntr+5],
string[cntr+6],string[cntr+7]);
printf("cntr=%d\n",cntr);
#endif
goto readline;
}
if(znak=='#')goto readline;

if((znak==' ')||(znak=='\0')){
string[cntr]='\0';

command=analyse_string(&string[lastanalysis]);
lastanalysis=cntr+1;
if(command==-1){
levelerror(num,line);
printf("  Unrecognized command \"%s\"\n",string);
exit(-1);
};
/*giant SWITCH
puts("Switching..GIANT SWITCH");
*/
switch(command){
case TITLE:
sprintf(LevelTitle,"%s",&string[cntr+1]);
#ifdef LEVEL_LOADER_DEBUG
printf("Level: %s\n",LevelTitle);
#endif
lastcommand=END;
goto readline;

case BACKGROUND:
sprintf(name,"%s/pics/%s",DIR,&string[cntr+1]);
n=strlen(name);
string[n-2]='\0';
#ifdef LEVEL_LOADER_DEBUG
printf("Background : %s\n",name);
#endif
if(picture!=NULL)free(picture);
if((picture=loadPCX(name))!=NULL){;
gl_setcontext(background); 
gl_putbox(0,0,320,192,picture);};
lastcommand=END;
goto readline;


case FROM:
if((lastcommand==ALIEN)||(lastcommand==SHELTER)){
levelerror(num,line);
puts("  ALIEN or SHELTER are lonely ones, set their position with AT command");
exit(-1);
}
fromx=getnum(&string[cntr+1]);
FROM_:
if(string[cntr]!=','){
if(string=='\0'){
levelerror(num,line);
puts("  FROM usage: FROM x,y");
exit(-1);
};
cntr++;
goto FROM_; 
};
fromy=getnum(&string[cntr+1]);
if((fromx<0)||(fromx>303)||(fromy<0)||(fromy>106)){
levelerror(num,line);
puts("  FROM: usable range for X:0..303, for Y:0..106");
exit(-1);
};
goto readline;

case TO:
if((lastcommand==ALIEN)||(lastcommand==SHELTER)){
levelerror(num,line);
puts("  ALIEN or SHELTER are lonely ones, set their position by with AT command");
exit(-1);
};
tox=getnum(&string[cntr+1]);
cntr++;
TO_:
if(string[cntr]!=','){
if(string=='\0'){
levelerror(num,line);
puts("  TO usage: TO x,y");
exit(-1);
};
cntr++; 
goto TO_;
};
toy=getnum(&string[cntr+1]);
if((tox<0)||(tox>303)||(toy<0)||(toy>106)){
levelerror(num,line);
puts("  TO: usable range for X:0..303, for Y:0..106");
exit(-1);
};
goto readline;


case AT:
if((lastcommand==ALIENBOX)||(lastcommand==ALIENLINE)){
levelerror(num,line);
puts("  ALIENBOX or ALIENLINE are groups, set their position with FROM&TO command");
exit(-1);
};
atx=getnum(&string[cntr+1]);
AT_:
if(string[cntr]!=','){
if(string=='\0'){
levelerror(num,line);
puts("  AT usage: AT x,y");
exit(-1);
};
cntr++;
goto AT_; 
};
if((atx<0)||(atx>303)){
levelerror(num,line);
puts("  X value in AT must be between 0 and 303 !");
exit(-1);
};
aty=getnum(&string[cntr+1]);
#ifdef LEVEL_LOADER_DEBUG
printf("AT:aty[%d]=%d\n",cntr,aty);
#endif
if((lastcommand==ALIEN)&&(aty>106)){
levelerror(num,line);
puts("  maximal Y value for ALIEN is 106");
exit(-1);
};

if((lastcommand==SHELTER)&&((aty<120)||(aty>168))){
levelerror(num,line);
puts("  Y value for SHELTER is between 120 and 168");
exit(-1);
};
goto readline;

case ALIEN:if (lastcommand!=END){
levelerror(num,line);
puts("  no END directive found before command ALIEN");
exit(-1);
};
lastcommand=ALIEN;goto readline;

case ALIENBOX:
if (lastcommand!=END){
levelerror(num,line);
puts("  no END directive found before command ALIENBOX");
exit(-1);
};
lastcommand=ALIENBOX;goto readline;

case ALIENLINE:
if (lastcommand!=END){
levelerror(num,line);
puts("  no END directive found before command ALIENLINE");
exit(-1);
};
lastcommand=ALIENLINE;goto readline;

case SHELTER:
if (lastcommand!=END){
levelerror(num,line);
puts("  no END directive found before command SHELTER");
exit(-1);
};
lastcommand=SHELTER;goto readline;

case TYPE:
type=getnum(&string[cntr+1]);
goto readline;

case HOWMANY:
if((lastcommand==ALIEN)||(lastcommand==SHELTER)){
levelerror(num,line);
puts("  ALIEN or SHELTER are lonely ones, HOWMANY command is illegal");
exit(-1);
};
howmanyx=getnum(&string[cntr+1]);
if(lastcommand==ALIENBOX){
cntr++;
HOWMANY_Y:
if(string[cntr]!=','){
if(string[cntr]=='\0'){
levelerror(num,line);
puts("  usage : ALIENBOX HOWMANY x,y");
exit(-1);
};
cntr++;
goto HOWMANY_Y; };
howmanyy=getnum(&string[cntr+1]);};
goto readline;

case MOVEMENT:
switch(analyse_string(&string[cntr+1])){
case NONE:movement=NONE;goto readline;
case CHAOTIC:movement=CHAOTIC;goto readline;
case LINEAR:
movement=LINEAR;

cntr+=8;
vx=getnum(&string[cntr]);
Linear_vy:
if(string[cntr]!=','){
if(string[cntr]=='\0'){
levelerror(num,line);
puts("  MOVEMENT LINEAR usage: MOVEMENT LINEAR vx,vy");
exit(-1);
};
cntr++;
goto Linear_vy;
};
vy=getnum(&string[cntr+1]);
#ifdef LEVEL_LOADER_DEBUG
printf("Movement linear:vy[%d]=%d\n",cntr,vy);
#endif
goto readline;

default:
levelerror(num,line);
puts("  MOVEMENT:maybe NONE, CHAOTIC or LINEAR vx,vy");
exit(-1);
};goto readline;

case END:
switch(lastcommand){
case ALIEN:
#ifdef LEVEL_LOADER_DEBUG
puts("Adding ALIEN");
if(movement==LINEAR)printf("Linear: vx=%d,vy=%d\n",vx,vy);
#endif
XX[enemies].movement=movement;
if((type<0)||(type>=ALIENS)){
levelerror(num,line);
printf("  Maximal value for alien type is %d, %d is not valid\n",ALIENS,type);
exit(-1);
} 
XX[enemies].alientype=type;
XX[enemies].vx=vx;
XX[enemies].vy=vy;
XX[enemies].x=(float)atx;
XX[enemies].y=(float)aty;
XX[enemies].status=TRANSMITTED;
XX[enemies].shields=alienguns[type].shields;
XX[enemies].counter=0;
XX[enemies].hitted=NO;
enemies++;
lastcommand=END;
goto readline;

case ALIENBOX:
#ifdef LEVEL_LOADER_DEBUG
puts("Adding ALIENBOX");
if(movement==LINEAR)printf("Linear: vx=%d,vy=%d\n",vx,vy);
#endif
if((enemies+howmanyx*howmanyy)>MAXALIENSINLEVEL){
levelerror(num,line);
printf("  Maximum of aliens in one level is %d\n",MAXALIENSINLEVEL);
exit(-1);
}

if((type<0)||(type>=ALIENS)){
levelerror(num,line);
printf("  Maximal value for alien type is %d, %d is not valid\n",ALIENS,type);
exit(-1);
}

if((howmanyx<=0)||(howmanyy<=0)){
levelerror(num,line);
printf(" number in HOWMANY must be >=1 !!");
exit(-1);
};
for(n1=0;n1<howmanyx;n1++)
for(n2=0;n2<howmanyy;n2++){
XX[enemies].movement=movement;
XX[enemies].vx=vx;
XX[enemies].vy=vy;
XX[enemies].alientype=type;
XX[enemies].x=(float)(fromx+(n1*(tox-fromx))/howmanyx);
XX[enemies].y=(float)(fromy+(n2*(toy-fromy))/howmanyy);
XX[enemies].status=TRANSMITTED;
XX[enemies].shields=alienguns[type].shields;
XX[enemies].counter=0;
XX[enemies].hitted=NO;
enemies++;
};
lastcommand=END;
goto readline;

case ALIENLINE:
#ifdef LEVEL_LOADER_DEBUG
puts("Adding alien line");
if(movement==LINEAR)printf("Linear: vx=%d,vy=%d\n",vx,vy);
#endif
if((enemies+howmanyx)>MAXALIENSINLEVEL){
levelerror(num,line);
printf("  Maximum of aliens in one level is 100");
exit(-1);
}
if((type<0)||(type>=ALIENS)){
levelerror(num,line);
printf("  Maximal value for alien type is %d, %d is not valid\n",ALIENS,type);
exit(-1);
}
if(howmanyx<=0){
levelerror(num,line);
printf(" number in HOWMANY must be >=1 !!");
exit(-1);
};
for(n1=0;n1<howmanyx;n1++){
XX[enemies].movement=movement;
XX[enemies].vx=vx;
XX[enemies].vy=vy;
XX[enemies].alientype=type;
XX[enemies].x=(float)(fromx+(n1*(tox-fromx))/howmanyx);
XX[enemies].y=(float)(fromy+(n1*(toy-fromy))/howmanyx);
XX[enemies].status=TRANSMITTED;
XX[enemies].shields=alienguns[type].shields;
XX[enemies].counter=0;
XX[enemies].hitted=NO;
enemies++;
};
lastcommand=END;
goto readline;

case SHELTER:
#ifdef LEVEL_LOADER_DEBUG
puts("Adding shelter");
if(movement==LINEAR)printf("Linear: vx=%d,vy=%d\n",vx,vy);
#endif
Shelter[no_of_shelters].movement=movement;
if((type<0)||(type>=(SHELTERS/3))){
levelerror(num,line);
printf("  Maximal value for alien type is %d, %d is not valid\n",SHELTERS/3,type);
exit(-1);
} 
if(no_of_shelters>=MAXSHELTERSINLEVEL){
levelerror(num,line);
puts("  maximum of shelters in level is 20!");
exit(-1);
};
Shelter[no_of_shelters].type=type;
Shelter[no_of_shelters].vx=vx;
Shelter[no_of_shelters].vy=vy;
Shelter[no_of_shelters].x=(float)atx;
Shelter[no_of_shelters].y=(float)aty;
Shelter[no_of_shelters].counter=35*type+70;
Shelter[no_of_shelters].hitted=NO;
no_of_shelters++;
lastcommand=END;
goto readline;

default:break;
};
/*end of case:END switch*/


default:break;
};
}
cntr++;
goto nextchar;

fin:

fclose(file);
#ifdef LEVEL_LOADER_DEBUG
printf("Level %d loaded. No. of enemies: %d\n",num,enemies);
#endif
return 0;
}
