struct ColorValue
{
unsigned char R;
unsigned char G;
unsigned char B;
} pal[256];

int xmin,xmax,ymin,ymax,Xmax,scale,n5,bef,now,bpl,rc,gc,bc,filelength,filepos;
int vgaxdim,vgaydim,picsize;
char string[100];

struct pcx_header {
int byte[128];
int prefix;
unsigned pal_yes_no :1;
} header;



int next_char(void){
int znak;
znak=fgetc(pcx_in);
filepos++;
if (filepos<=filelength)
return znak;
else
{puts("pcxv:unexpected end of file");
fclose(pcx_in);
exit(0);};
return 0;
}


void read_pal(){
int n1;
if(next_char()==0x0c){
for(n1=0;n1<256;n1++){
pal[n1].R=((unsigned char)(next_char()))/4;
pal[n1].G=((unsigned char)(next_char()))/4;
pal[n1].B=((unsigned char)(next_char()))/4;
};
}
else printf("Hasn't got a color palette !!");
}




void plotpoint (int px,int py,unsigned char col,unsigned char *picture){
int adress;
adress=px+py*(xmax-xmin+1);
if(adress>=picsize){
printf("trying to write to \'picture[%d]\' -> exiting\n",adress);
exit(-1); 
}
if(col>=240u){
printf("PCX has too much colors. Trying to store no.%u\n",col);
puts("But PCX must be in 256 mode");
exit(-1);
}
picture[adress]=col+(unsigned char)palettecounter;

}

int getcol(int px,int py){
if(px>=xmax)return 0;
if(py>=ymax)return 0;
return (int)picture[px+py*(xmax-xmin)];
}

unsigned int adresa,bef2,adr2;
unsigned long myaddr,myaddr2;
int adr3;

void *loadPCX(char *filename){
unsigned char *picture=NULL;
int znak,n1,n2,n3,n4,xpos,ypos,znak1,aa1;
if((pcx_in=fopen(filename,"rb"))==NULL){
printf("\nCannot open %s\n",filename);
goto finish;};
fseek(pcx_in, 0, SEEK_END);
filelength = ftell(pcx_in);
fseek(pcx_in, 0, SEEK_SET);
filepos=0L;
for(n1=0;n1<128;n1++){
header.byte[n1]=next_char();
};
if(header.byte[0]!=0x0a){
puts ("\nNot a  PCX format");
exit(-1);};
if(header.byte[2]!=1) 
{puts("Unknown PCX coding!");exit(-1);};
bpl=header.byte[66]+header.byte[67]*256;
aa1=header.byte[68]+header.byte[69]*256;

xmin=header.byte[4]+256*header.byte[5];
xmax=header.byte[8]+256*header.byte[9];
ymin=header.byte[6]+256*header.byte[7];
ymax=header.byte[10]+256*header.byte[11];
Xmax=xmax-1;
n1=header.byte[1];
n2=header.byte[3];
n3=header.byte[65];
n4=header.byte[68]+header.byte[69]*256;
header.pal_yes_no=0;
if(((n1==2)||(n1==5))&&(n2==8)&&(n3==1)&&(n4!=2)) header.pal_yes_no=1;

if((n4!=2)&&(header.byte[3]==8)){
filepos=128;
fseek(pcx_in,filepos,SEEK_SET);
xmax=((header.byte[66]+header.byte[67]*256)*8/n2) -1;
picsize=(xmax-xmin+1)*(ymax-ymin+1);
/*printf("Allocating %d bytes of memory\n",picsize);*/
picture=(unsigned char*)malloc(picsize);
if(picture==NULL){
printf("Not enough memory. %d bytes needed\n",picsize);
exit(-1);
}
xpos=xmin;ypos=ymin;
contin8:
znak=next_char();
if(znak<192){
plotpoint(xpos-xmin,ypos-ymin,znak,picture);
xpos++;
if(xpos>xmax){
xpos=xmin;ypos++;};
if(ypos>ymax) goto contin9;
goto contin8;
};
znak1=next_char();
for(n1=0;n1<(znak-192);n1++){
plotpoint(xpos-xmin,ypos-ymin,znak1,picture);
xpos++;
if(xpos>xmax){
xpos=xmin;ypos++;};};
if(ypos<=ymax) goto contin8;
contin9:
read_pal();
for(n1=palettecounter;n1<(palettecounter+240);n1++)
vga_setpalette(n1,(int) pal[n1-palettecounter].R,(int)pal[n1-palettecounter].G,(int)pal[n1-palettecounter].B);
palettecounter+=240;}
else {puts("Not a 256 color PCX");exit(-1);}
finish:
if(pcx_in!=NULL)fclose(pcx_in);
return picture;
}