#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgakbd.h>
#include <vgamouse.h>
#include <malloc.h>
#include <unistd.h>

/*
This is a simple graphic editor for sprite editing. Format is only 16x16
points. To edit 'file' start it as 'Sprited file'. One byte = one pixel,
but colors are between 0 and 15. First 256 bytes are colors and next
256 bytes is mask. If mask[x]
*/

FILE *cursor_file;

int VGAMODE;
int VIRTUAL;

#define CURSOR_CENTER_X 8
#define CURSOR_CENTER_Y 8


GraphicsContext *backscreen;
GraphicsContext *physicalscreen;

int palettecounter,mousex,mousey;
unsigned char mouse_cursor[2][256],mouse_under[256],cbuf[256];
unsigned char mouse_buffer[256],cursor_old[2][256];
unsigned char cursor[2][256],font[256][8][8],mouse_backup[2][256];

int xmin,xmax,ymin,ymax,Xmax,scale,n5,bef,now,bpl,rc,gc,bc,filelength,filepos;
int vgaxdim,vgaydim,picsize;
char string[100];

/*cursor[0][] is cursor
cursor[1][] is mask (==0 is visible trough)*/

void repaint(void){
int x,y,n1;
gl_fillbox(0,70,16,16,0);
for(y=0;y<16;y++)
for(x=0;x<16;x++)
{
n1=x+y*16;
if(cursor[1][n1]==0)gl_write(x*9+20,y*9+20,"X");
else gl_fillbox(x*9+20,y*9+20,7,7,(int)cursor[0][n1]);
};
}


int mouse_work(void){
int n,nr,xmin,w,h,xm,ym,x0,y0,x,y,offs;
/*Puvodni verze
gl_getbox(mousex,mousey,16,16,mouse_under);
for(n=0;n<256;n++)
mouse_buffer[n]=((mouse_cursor[1][n]==0u)?mouse_under[n]:mouse_cursor[0][n]);
gl_putbox(mousex,mousey,16,16,mouse_buffer);
mouse_waitforupdate();
gl_putbox(mousex,mousey,16,16,mouse_under);
mousex=mouse_getx();
mousey=mouse_gety();
return mouse_getbutton();
*/

xm=mousex;
ym=mousex;
x0=CURSOR_CENTER_X;
y0=CURSOR_CENTER_Y;

h=((mousey-y0)>(199-16))?(199-(mousey-y0)):16;

if((xm>=x0)&&(xm<(319-(15-x0)))){
gl_getbox(mousex-x0,mousey-y0,16,h,mouse_under);
for(n=0;n<256;n++)
mouse_buffer[n]=((mouse_cursor[1][n]==0u)?mouse_under[n]:mouse_cursor[0][n]);
gl_putbox(mousex-x0,mousey-y0,16,h,mouse_buffer);
usleep(10000);
mouse_waitforupdate();
gl_putbox(mousex-x0,mousey-y0,16,h,mouse_under);
mousex=mouse_getx();
mousey=mouse_gety();
return mouse_getbutton();

}

if(xm<x0){xmin=0;w=mousex+(15-x0);offs=15-w;}
else {xmin=mousex-x0;w=319-xmin;offs=0;};

gl_getbox(xmin,mousey-y0,w,h,cbuf);

for(x=0;x<w;x++)
for(y=0;y<h;y++)
{
n=x+y*w;
nr=x+y*16+offs;
mouse_buffer[n]=((mouse_cursor[1][nr]==0u)?cbuf[n]:mouse_cursor[0][nr]);
};

gl_putbox(xmin,mousey-y0,w,h,mouse_buffer);
usleep(10000);
mouse_waitforupdate();
gl_putbox(xmin,mousey-y0,w,h,cbuf);
mousex=mouse_getx();
mousey=mouse_gety();
return mouse_getbutton();

}


int mouse_x(void){
return mousex;
}

int mouse_y(void){
return mousey;
}


void main(int argc, char *argv[]){

int pitch,voffset,vpitch,w,h,key,x0,y0,x,y,n1,n2,n3,n4,mouse,lines,color;
int in_test,isfile;
char *filename,string[100];
unsigned char znak,znak_str[2];
if (argc!=2){
puts("Simple bitmap editor");
puts("For 256 colors, size 16x16, masked");
puts("Usage: Sprited filename");
puts("(c)P.V.C. software products, 1996");
exit(-1);
}
filename=argv[1];
if((cursor_file=fopen(filename,"rb"))==NULL){
printf("%s : new file\n",filename);
isfile=0;
}else
{
fread(cursor_old,512,1,cursor_file);
fclose(cursor_file);
}

vga_init();
VGAMODE = vga_getdefaultmode();
if (VGAMODE == -1)
 VGAMODE = G320x200x256; /* Default mode. */
          
 if (!vga_hasmode(VGAMODE)) {
 printf("Mode not available.\n");
 exit(-1);
 }
 VIRTUAL = 0;                /* No virtual screen. */
 if (vga_getmodeinfo(VGAMODE)->colors == 16 ||
 (vga_getmodeinfo(VGAMODE)->flags & IS_MODEX))
 /* These modes are supported indirectly by vgagl. */
 VIRTUAL = 1;
                                                         
 if (VIRTUAL) {
 /* Create virtual screen. */
 gl_setcontextvgavirtual(VGAMODE);
 backscreen = gl_allocatecontext();
 gl_getcontext(backscreen);
 }
 vga_setmode(VGAMODE);
 gl_setcontextvga(VGAMODE);  /* Physical screen context. */
 physicalscreen = gl_allocatecontext();
 gl_getcontext(physicalscreen);

mouse=vga_getmousetype();

if(mouse_init("/dev/ttyS0",mouse,MOUSE_DEFAULTSAMPLERATE)==-1){puts("mouse not found");
goto finish;};

mouse_setxrange(0,319);mouse_setyrange(0,199);
mouse_setposition(160,100);
mousex=mouse_getx();mousey=mouse_gety();
mouse_setscale(1);
mouse_setwrap(MOUSE_NOWRAP);

/*cursor painting and storing*/
gl_line(0,200-8,15,200-8,15);
gl_line(8,200-16,8,199,15);
gl_circle(8,200-8,5,8);
gl_getbox(0,200-16,16,16,mouse_cursor[0]);
gl_getbox(0,200-16,16,16,mouse_cursor[1]);
gl_fillbox(0,200-16,16,16,0);

if(VIRTUAL)gl_setcontext(backscreen);

gl_expandfont(8, 8, 7, gl_font8x8, font);
gl_setfont(8, 8, font);
gl_setwritemode(WRITEMODE_OVERWRITE);

memmove(cursor,cursor_old,512);
for(n1=0;n1<256;n1++)if(cursor[0][n1]>15u)cursor[0][n1]=15u;

for(n1=0;n1<16;n1++){
gl_line(309,n1*11,319,n1*11,15);
gl_line(319,n1*11,319,n1*11+9,15);
gl_line(319,n1*11+9,309,n1*11+9,15);
gl_line(309,n1*11+9,309,n1*11,15);
gl_fillbox(310,n1*11+1,9,8,n1);
}
gl_write(311,16*11+1,"X");
gl_line(309,16*11,319,16*11,15);
gl_line(319,16*11,319,16*11+9,15);
gl_line(319,16*11+9,309,16*11+9,15);
gl_line(309,16*11+9,309,16*11,15);

for(x=0;x<=16;x++)gl_line(x*9+19,19,x*9+19,16*9+19,8);
for(y=0;y<=16;y++)gl_line(19,y*9+19,16*9+19,y*9+19,8);

gl_setwritemode(WRITEMODE_MASKED);
gl_fillbox(0,199-9,320,9,1);
gl_write(0,191,"SAVE&QUIT         TEST  X=unmasked point");
gl_write(0,180,"color:");
gl_setwritemode(WRITEMODE_OVERWRITE);

gl_line(49,179,58,179,15);
gl_line(58,179,58,188,15);
gl_line(58,188,49,188,15);
gl_line(49,188,49,179,15);

for(x=0;x<16;x++)
for(y=0;y<16;y++)gl_fillbox(180+x*5,50+y*5,5,5,x+y*16);

color=7;/*default color*/
in_test=0;

znova:
repaint();
if(color!=-1)gl_fillbox(50,180,8,8,color);
else gl_write(50,180,"X");

for(;(n1=mouse_work())==0;);/*wait loop*/
if(in_test==1){
in_test=0;
memmove(mouse_cursor,mouse_backup,512);
}

if(n1==4){
if((mouse_x()<(16*9+19))&&(mouse_x()>20)&&(mouse_y()>20)&&(mouse_y()<(16*9+19))){
x=(mouse_x()-21)/9;
y=(mouse_y()-21)/9;

n1=(mouse_x()-21)%9;
n2=(mouse_y()-21)%9;
if((n1<=8)&&(n2<=8))switch(color){
case -1:cursor[1][x+y*16]=0;break;
default:cursor[0][x+y*16]=color;
cursor[1][x+y*16]=255;
break;
};
}


if(mouse_y()>189)
if((mouse_x()>151)&&(mouse_x()<184)){
in_test=1;
memmove(mouse_backup,mouse_cursor,512);
memmove(mouse_cursor,cursor,512);
};

if((mouse_x()<72)&&(mouse_y()>189))goto save_and_quit;
if(mouse_x()>309){
n2=(mouse_y()-1)/11;
n3=(mouse_y()-1)%11;
if(n3<8){
if((n2<16)&&(n2>=0))color=n2;
if(n2==16)color=-1;
};

};
 
};

goto znova;


save_and_quit:
cursor_file=fopen(filename,"wb");
fwrite(cursor,512,1,cursor_file);
fclose(cursor_file);
printf("File %s saved\n",filename);
finish:
mouse_close();
vga_clear();
vga_setmode(TEXT);
}




